
typedef struct fxeLandscape
{
  unsigned int *Landscapes;
  int NumLandscapesX;
  fxeVertex VertexWorld;
  fxeVertex VertexCamera;
  float Radius;
  fxeColor VertexColors[4];
  fxeVertex VerticesWorld[4];
  fxeVertex VerticesCamera[4];
  fxeTextureCoordinate TextureCoordinates[4];
  fxeTextureHandle TH;
  int TextureMode;
  fxeColor ClippedVertexColors1[4];
  fxeColor ClippedVertexColors2[4];
  fxeVertex ClippedVertices1[4];
  fxeVertex ClippedVertices2[4];
  fxeTextureCoordinate ClippedTextureCoordinates1[4];
  fxeTextureCoordinate ClippedTextureCoordinates2[4];
  int Clipped;
  int ClippedNearPlane;
  int NumAddedVertices1;
  int NumAddedVertices2;
} fxeLandscape, *fxeLandscapePtr;

typedef struct fxeHeightmapInfo
{
  int Width;
  float *MapData;
} fxeHeightmapInfo, *fxeHeightmapInfoPtr;

typedef struct fxeNormalBuffer
{
  fxeVector *Normals;
  int Width;
} fxeNormalBuffer, *fxeNormalBufferPtr;

typedef fxeLandscapePtr fxeLandscapeHandle;

fxeLandscapeHandle CurrLandscape;

fxeLandscapeHandle fxeLandscapeCreate64x64(float Width1, float Depth1,
  fxeTextureHandle TerrainTexture, int RandomSeed);

fxeLandscapeHandle
  fxeLandscapeCreateRandom(float Width, float Depth, fxeHeightmapInfoPtr
  pHeightmap, fxeNormalBufferPtr pNormalBuffer,
  fxeTextureHandle TerrainTexture, int Seed);

fxeLandscapePtr SetupLandscape(int LandscapeLevel,
  float Width, float Depth, int x, int z, fxeHeightmapInfoPtr pHeightmap,
  fxeTextureHandle TerrainTexture, int NumChildsX, fxeNormalBufferPtr
  pNormalBuffer);

fxeHeightmapInfoPtr fxeCreateHeightMap(fxeHeightmapInfoPtr pHeightmap,
  int NumRecs, int RecWidth, int RecHeight, int MapWidth);

void fxeFreeHeightMap(fxeHeightmapInfoPtr pHeightmap);


void fxeLandscapeAddToWorld(fxeLandscapeHandle pLandscape);

void fxeLandscapeRemoveFromWorld(void);

